/****************************************************************************
** Copyright (c) 2017, I.N.P.P. "DEMOKRITOS"
** All rights reserved.
**
**   Redistribution and use in source and binary forms, with or without
**   modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**      notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the I.N.P.P. "Demorkitos" nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL I.N.P.P. "DEMOKRITOS" BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#ifndef DB_H
   #define DB_H 1

   #include <string>
   #include <vector>
   #include <sstream>
   #include <fstream>
   #include <iostream>

   #include <QString>
   #include <QFileDialog>
   #include <QApplication>
   #include <QDebug>
   #include <QDir>
//   #include <boost/function.hpp>
//   #include <boost/bind.hpp>

  /* struct data {
      size_t n;
      double *t;
      double *yy;
      double *sigma;
   };

   typedef int (*f_function_type)(const gsl_vector * x, void *params, gsl_vector * f);
   typedef int (*df_function_type)(const gsl_vector * x, void *params, gsl_matrix * J);
   typedef int (*fdf_function_type)(const gsl_vector * x, void *params, gsl_vector * f, gsl_matrix * J);
   typedef double (*normal_function)(double, double*);
   typedef double (*derivative_function)(int, double, double*);*/

   class isotope {
      public:
         std::string Isotope_Name;
         int Atomic_Number;
         int Neutron_Number;
         int Mass_Number;
         double Abundance;
         double Mass;
      public:
         isotope();
         isotope(std::string, int, int, int,double, double);
   };

  // std::vector < isotope > create_isotopes();

////////////////////////////////////Element class definition///////////////
   class element{
      public:
         std::string Element_Name;
         int Atomic_Number;
         std::vector <int> Neutron_Number;
         std::vector <int> Mass_Number;
         std::vector <double> Mass;
         std::vector <double> Abundance;

      public:
         element();
         element(std::string, int, std::vector <int>,std::vector <int>,
                 std::vector<double>, std::vector<double>);
   };

   std::vector < element > create_elements();


////////////////////////////////////Target class definition///////////////


   class target_element : public element
   {
   public:
       element atom;
       double atomic_percent;
       int fit_state;      // 0=Free 1=Fit 2=Fixed
       std::vector<int> linked_elem;
       std::vector<double> linked_ratio;

    public:
       target_element();
       target_element(element, double, int,std::vector<int>,std::vector<double>);

   };
   bool operator<(const target_element &s1, const target_element &s2);

////////////////////////////////////Reaction class definition///////////////

   class reaction
   {
   public:
       int Atomic_Number;
       int Mass_Number;
       std::string Reaction_Name;
       float Theta;
       std::string filename;
       float Egamma;
       float E_min, E_max;
       int No_of_points;
       std::string Source;
   public:
       reaction();
       reaction(int,int, float,float,int,float,float,std::string,std::string,std::string);
   };

  std::vector < reaction > create_reaction_list();
std::vector < isotope > create_isotopes();
  isotope find_isotope_by_name(std::vector<isotope> , QString );
  int find_isotope_by_Z(std::vector<isotope> , QString);
  QString find_element_by_name(std::vector<element> , QString);

#endif // DATABASE_H
