/****************************************************************************
** Copyright (c) 2017, I.N.P.P. "DEMOKRITOS"
** All rights reserved.
**
**   Redistribution and use in source and binary forms, with or without
**   modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**      notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the I.N.P.P. "Demorkitos" nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL I.N.P.P. "DEMOKRITOS" BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#ifndef REACTIONWINDOW_H
#define REACTIONWINDOW_H


#include "math.h"

#include <QMainWindow>
#include <QtGui>
#include <QDialog>
#include <QStatusBar>

#include <iostream>
#include <iomanip>
#include <fstream>
#include <iostream>
#include <vector>

#include "mainwindow.h"
#include "Database.h"

QT_BEGIN_NAMESPACE
   class QAction;
   class QDialogButtonBox;
   class QGroupBox;
   class QLabel;
   class QLineEdit;
   class QMenu;
   class QMenuBar;
   class QPushButton;
   class QTextEdit;
   class QSpinBox;
   class QStatusBar;
   class QComboBox;
   class QMessageBox;
   class QIcon;
   class QSize;
   class QDialog;
   class QCheckBox;
   class QTabWidget;
   class QGridLayout;
   class QWidget;
   class QTableWidget;
QT_END_NAMESPACE

class MainWindow;

class ReactionWindow : public QMainWindow {
Q_OBJECT

private:
    std::vector <reaction> Possible_reactions;
    std::vector <reaction> Temp_reactions;

signals:
    void sendreact(std::vector <reaction> Possible_reactions);

public:
   ReactionWindow(class MainWindow *testkk);
   //  void resizeEvent ( QResizeEvent *event );

protected :
   void closeEvent(QCloseEvent *event);

private slots:
   void choose_cs();
   void checkbox_check();

private:
   void file_error();
   void setStatusBar();
   void createMenu();
   void createHorizontalGroupBox();
   void createGridGroupBox();
   void createFormGroupBox();
   void writeSettings();
   void readSettings();
   void loadFile(const QString &fileName);
   void setCurrentFile(const QString &fileName);
   void createStatusBar();
   class MainWindow *local_main_window;
   enum { NumGridRows = 3, NumButtons = 4 };

   QString curFile;
   QMenuBar *menuBar;
   QGroupBox *horizontalGroupBox;
   QGroupBox *gridGroupBox;
   QGroupBox *formGroupBox;
   QTextEdit *smallEditor;
   QTextEdit *bigEditor;
   QLineEdit *lineEdits[NumGridRows];
   QPushButton *open_button, *fit_button, *draw_button;
   QPushButton *choose_button;
   QDialogButtonBox *buttonBox;
   QSpinBox *lala, *eff_spin;
   QMenu *fileMenu;
   QAction *exitAction;
   QComboBox *func_combo;
   QMessageBox *msgBox;
   QIcon *func_icon;
   QDialog *plotWin;
   QCheckBox *cross_check[50];
   QTabWidget *element_tab;
   QGridLayout *tablayout[5];
   QWidget *tabs[5];
   QTableWidget *react_table[5];

};


#endif // REACTIONWINDOW_H
