/****************************************************************************
** Copyright (c) 2017, I.N.P.P. "DEMOKRITOS"
** All rights reserved.
**
**   Redistribution and use in source and binary forms, with or without
**   modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**      notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the I.N.P.P. "Demorkitos" nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL I.N.P.P. "DEMOKRITOS" BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#ifndef TARGETWINDOW_H
#define TARGETWINDOW_H

#include <QMainWindow>
#include <QtGui>
#include <QDialog>
#include <QStatusBar>

#include <iostream>
#include <iomanip>
#include <fstream>
#include <iostream>
#include <vector>

#include <algorithm>
#include "mainwindow.h"
#include "Database.h"

QT_BEGIN_NAMESPACE
   class QAction;
   class QDialogButtonBox;
   class QGroupBox;
   class QLabel;
   class QLineEdit;
   class QMenu;
   class QMenuBar;
   class QPushButton;
   class QSpinBox;
   class QStatusBar;
   class QComboBox;
   class QMessageBox;
   class QListWidget;
   class QDoubleSpinBox;
   class QIcon;
   class QSize;
   class QDialog;
   class QCheckBox;
   class QGridLayout;
   class QWidget;
   class QScrollArea;
QT_END_NAMESPACE

class MainWindow;

class TargetWindow : public QMainWindow {
Q_OBJECT

private:
    int value;

signals:
    void sendTarget(std::vector < target_element > Target);


public:
   TargetWindow(class MainWindow *testkk);
   //  void resizeEvent ( QResizeEvent *event );
   std::vector < target_element > Target;
   double add_fract;


protected :
   void closeEvent(QCloseEvent *event);
 //  void changeEvent(QEvent *event);


private slots:
   void fill_perc();
   void no_elements();
   void check_perc();
   void check_elem();
   void check_linked();
   void load_Target();
   void save_Target();
   void link_elem();
   void ok_pressed();

private:
   void error_code(int);
   void setStatusBar();
   void createMenu();
   void createHorizontalGroupBox();
   void createGridGroupBox();
   void createFormGroupBox();
   void writeSettings();
   void readSettings();
   void createStatusBar();
   void fill_link_combo();
   class MainWindow *local_main_window;

   std::vector < element > Elements;
   std::vector<int> linked_elem;
   std::vector<double> linked_ratio;

   QPushButton *link_button[10], *fill_button[10], *ok_button;
   QDoubleSpinBox *atomic_perc_spin[10],*link_perc_spin[10];
   QSpinBox *no_elements_spin;
   QLabel *no_elements_label;
   QAction *exitAction;
   QComboBox *element_combo[10], *behav_combo[10],*link_combo[10];
   QMessageBox *msgBox;
   QWidget *container;
   QLabel *empty[10],*cempty[10];
   QListWidget *targetList;
   QScrollArea *scrollArea;

   void createActions();
       QMenu *optionsMenu;
       QAction *loadTargetAct;
       QAction *saveTargetAct;

   void createMenus();
};
#endif // TARGETWINDOW_H
