/****************************************************************************
** Copyright (c) 2017, I.N.P.P. "DEMOKRITOS"
** All rights reserved.
**
**   Redistribution and use in source and binary forms, with or without
**   modification, are permitted provided that the following conditions are met:
**     * Redistributions of source code must retain the above copyright
**      notice, this list of conditions and the following disclaimer.
**     * Redistributions in binary form must reproduce the above copyright
**       notice, this list of conditions and the following disclaimer in the
**       documentation and/or other materials provided with the distribution.
**     * Neither the name of the I.N.P.P. "Demorkitos" nor the
**       names of its contributors may be used to endorse or promote products
**       derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
** WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL I.N.P.P. "DEMOKRITOS" BE LIABLE FOR ANY
** DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
** (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
** LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
** ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
** SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#include "TargetWindow.h"
#include "Database.h"
#include <QDesktopWidget>
TargetWindow :: TargetWindow(MainWindow *main_window)
{

this->setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowTitleHint | Qt::WindowMinMaxButtonsHint);
    local_main_window = main_window;    //// small trick to pass main_window to the slot
 //   QSize size = local_main_window->sizeHint();
    this->setWindowTitle("Target");
  //  this->setFixedSize(500,200);
    Elements = create_elements();

  //  QDesktopWidget* desktop = QApplication::desktop();
  //  int width = desktop->width();
  //  int height = desktop->height();
  //  int mw = size.width();
  //  int mh = size.height();
  //  int centerW = (width/2) - (mw/2);
  //  int centerH = (height/2) - (mh/2);

    QGridLayout *layout = new QGridLayout;


      this->setGeometry(300, 300,500,500);
  //     local_main_window->setGeometry(centerW, centerH,200,200);
 //  setGeometry(geometry().x(), geometry().y(), 200, 200);
  // QGridLayout *layout = new QGridLayout;

    QGridLayout *layout_area = new QGridLayout;

    for(unsigned int i=0;i<10;i++)
 {
        cempty[i] = new QLabel();

        switch (i)
        {
            case 0 :
                cempty[i]->setFixedSize(1,1);
                break;
            case 1 : case 2 : case 3 : case 6 : case 7 :
                 cempty[i]->setFixedSize(80,1);
                break;
            default:
                 cempty[i]->setFixedSize(30,1);
         }
}
   for(unsigned int i=0;i<10;i++)
{
       empty[i] = new QLabel();
       empty[i]->setFixedSize(1,30);

    element_combo[i] = new QComboBox();
    element_combo[i]->setSizePolicy(QSizePolicy::Ignored,QSizePolicy::Fixed);
    element_combo[i]->setFocusPolicy(Qt::ClickFocus);
    element_combo[i]->setFixedSize(80,30);
    element_combo[i]->addItem(" ");
    for(unsigned int j=0; j<Elements.size();j++)
        element_combo[i]->addItem(QString(Elements[j].Element_Name.c_str()));
    connect(element_combo[i], SIGNAL(currentIndexChanged(int)), this, SLOT(check_elem()));


    behav_combo[i] = new QComboBox;
    behav_combo[i]->addItem("Free");
    behav_combo[i]->addItem("Fit");
    behav_combo[i]->addItem("Fixed");
    behav_combo[i]->setFixedSize(80,30);
    connect(behav_combo[i], SIGNAL(activated(int)), this, SLOT(check_linked()));

    atomic_perc_spin[i] = new QDoubleSpinBox;
    atomic_perc_spin[i]->setValue(0);
    atomic_perc_spin[i]->setRange(0,1);
    atomic_perc_spin[i]->setDecimals(5);
    atomic_perc_spin[i]->setKeyboardTracking(false);
    atomic_perc_spin[i]->setButtonSymbols(QAbstractSpinBox::NoButtons);
    atomic_perc_spin[i]->setFixedSize(80,30);

    fill_button[i] = new QPushButton(tr("F"));
    fill_button[i]->setDisabled(false);
    fill_button[i]->setFocusPolicy(Qt::ClickFocus);
    fill_button[i]->setFixedSize(20,30);
    connect(fill_button[i], SIGNAL(released()), this, SLOT(fill_perc()));

    link_button[i] = new QPushButton(tr("L"));
    link_button[i]->setDisabled(false);
    link_button[i]->setFixedSize(20,30);
    link_button[i]->setFocusPolicy(Qt::ClickFocus);
    connect(link_button[i], SIGNAL(released()), this, SLOT(link_elem()));


    link_combo[i] = new QComboBox();
    link_combo[i]->setFixedSize(80,30);

    link_perc_spin[i] = new QDoubleSpinBox;
    link_perc_spin[i]->setValue(0);
    link_perc_spin[i]->setRange(0,10);
    link_perc_spin[i]->setDecimals(3);
    link_perc_spin[i]->setFixedSize(80,30);

    link_combo[i]->setHidden(true);
    element_combo[i]->setHidden(true);
    behav_combo[i]->setHidden(true);
    atomic_perc_spin[i]->setHidden(true);
    fill_button[i]->setHidden(true);
    link_button[i]->setHidden(true);
    link_perc_spin[i]->setHidden(true);


    // element_combo[i]->move(0,0);
    connect(atomic_perc_spin[i], SIGNAL(valueChanged(double)), this, SLOT(check_perc()));

    layout_area->addWidget(element_combo[i],1+i,1);
    layout_area->addWidget(behav_combo[i],1+i,2);
    layout_area->addWidget(atomic_perc_spin[i],1+i,3);
    layout_area->addWidget(fill_button[i],1+i,4);
    layout_area->addWidget(link_button[i],1+i,5);
    layout_area->addWidget(link_combo[i],1+i,6);
    layout_area->addWidget(link_perc_spin[i],1+i,7);

    layout_area->addWidget(empty[i],1+i,0);
    layout_area->addWidget(cempty[i],0,0+i);
}

   container = new QWidget();
   scrollArea = new QScrollArea;
   scrollArea->setWidgetResizable(true);
   scrollArea->setWidget(container);

   container->setLayout(layout_area);

   layout->addWidget(scrollArea,2,0,5,2);

   no_elements_spin = new QSpinBox();
   connect(no_elements_spin, SIGNAL(valueChanged(int)), this, SLOT(no_elements()));
   no_elements_spin->setValue(2);
   no_elements_spin->setRange(2,10);
   no_elements_spin->setKeyboardTracking(false);
   layout->addWidget(no_elements_spin,0,1);

   no_elements_label = new QLabel();
   no_elements_label->setText("No of elements");
   layout->addWidget(no_elements_label,0,0);


   ok_button = new QPushButton(tr("OK"));
   ok_button->setDisabled(false);
 //  ok_button[i]->setFixedSize(20,30);
   connect(ok_button, SIGNAL(released()), this, SLOT(ok_pressed()));
   layout->addWidget(ok_button,10,0,1,2);


      QWidget *window = new QWidget();
      window->setLayout(layout);
      setCentralWidget(window);
      menuBar()->setNativeMenuBar(false); //necessary to override MacOs menu
      createActions();
      createMenus();

}
void TargetWindow::link_elem()
{

   for(unsigned int i=0; i< (unsigned int)no_elements_spin->value();i++)
    {
       if(link_button[i]->hasFocus()==true)
       {
           if(link_combo[i]->isVisible() == false)
           {
             link_combo[i]->setHidden(false);
             link_perc_spin[i]->setHidden(false);
             for(unsigned int k=0; k< (unsigned int)no_elements_spin->value();k++)
                 if(k!=i && behav_combo[k]->currentIndex() == 0)
                 link_combo[i]->addItem(element_combo[k]->currentText());
           }
           else
           {
             link_combo[i]->setHidden(true);
             link_perc_spin[i]->setHidden(true);
             link_combo[i]->clear();
           }
        }
     }
}

void TargetWindow::check_linked()    /// Appear / Dissapear the link button
{

  for(unsigned int i=0; i<(unsigned int)no_elements_spin->value();i++)
    {
       if( behav_combo[i]->currentText() =="Fit")
       {
           if(link_button[i]->isHidden() == true)
                link_button[i]->setHidden(false);
       }
       else
       {
           link_button[i]->setHidden(true);
           link_combo[i]->setHidden(true);
           link_perc_spin[i]->setHidden(true);
       }
     }

     fill_link_combo();
}


void TargetWindow::check_perc()
{
    add_fract=0;

    QMessageBox msgBox;

    for(unsigned int k=0;k<(unsigned int)no_elements_spin->value();k++)
        add_fract += atomic_perc_spin[k]->value();

    if(add_fract > 1)
    {
        for(unsigned int i=0;i<(unsigned int)no_elements_spin->value();i++)
            if(atomic_perc_spin[i]->hasFocus())
                atomic_perc_spin[i]->setValue(0);

        msgBox.setWindowTitle("Error");
        msgBox.setIcon(QMessageBox::Critical);
        msgBox.setText("Concentrations should equal 1");
        msgBox.exec();

    }

}
void TargetWindow::check_elem()
{
   for(unsigned int i=0;i<(unsigned int)no_elements_spin->value();i++)
           if(element_combo[i]->hasFocus())
               for(unsigned int j=0;j<(unsigned int)no_elements_spin->value();j++)
                   if(element_combo[i]->currentIndex() == element_combo[j]->currentIndex() && i!=j)
                          element_combo[i]->setCurrentIndex(0);

fill_link_combo();
}

void TargetWindow::no_elements()
{
    for(int i=0;i<10;i++)
    {
        if(i<no_elements_spin->value())
        {
   //       qDebug() << no_elements_spin->value();
          element_combo[i]->setHidden(false);
          behav_combo[i]->setHidden(false);
          atomic_perc_spin[i]->setHidden(false);
          fill_button[i]->setHidden(false);
          if(behav_combo[i]->currentIndex() == 1)
          {
             link_button[i]->setHidden(false);
    //         if(link_perc_spin)
    //         link_perc_spin[i]->setHidden(false);
    //         link_combo[i]->setHidden(false);
          }
        }

        else
        {
          element_combo[i]->setHidden(true);
          behav_combo[i]->setHidden(true);
          atomic_perc_spin[i]->setHidden(true);
          fill_button[i]->setHidden(true);
          behav_combo[i]->setCurrentIndex(0);
          atomic_perc_spin[i]->setValue(0);
          element_combo[i]->setCurrentIndex(0);
          if(behav_combo[i]->currentIndex() != 1)
          {
              link_button[i]->setHidden(true);
              link_perc_spin[i]->setHidden(true);
              link_combo[i]->setHidden(true);
          }
        }
    }
    fill_link_combo();

}


void TargetWindow::fill_perc()
{
    int pos=0;
    double tot_perc = 0;
        for(int i=0;i<no_elements_spin->value();i++)
        {
           if(atomic_perc_spin[i]->value() != 0 && !fill_button[i]->hasFocus()) tot_perc += atomic_perc_spin[i]->value();
           if(fill_button[i]->hasFocus()) pos=i;
        }
        atomic_perc_spin[pos]->setValue(1-tot_perc);
    //    qDebug()<<pos;
}

void TargetWindow::ok_pressed()
{
    Target.clear();

    for(unsigned int i=0;i<(unsigned int)no_elements_spin->value();i++)
    {

        if(link_perc_spin[i]->value() != 0 )
        {
            linked_elem.push_back(link_combo[i]->currentIndex());
            linked_ratio.push_back(link_perc_spin[i]->value());
        }
        else
        {
            linked_elem.push_back(0);
            linked_ratio.push_back(0);
        }

          if(element_combo[i]->currentIndex() == 0)
          {
              Target.clear();
       //       emit sendTarget(Target);
              this->close();
              return;
           }
        Target.push_back(target_element(Elements[element_combo[i]->currentIndex()-1],
                         atomic_perc_spin[i]->value(),
                         behav_combo[i]->currentIndex(),linked_elem,linked_ratio));
        linked_elem.clear();
        linked_ratio.clear();
    }
    int j=0;
    for(unsigned int i=0;i<(unsigned int)no_elements_spin->value();i++)
    {
         if(behav_combo[i]->currentIndex()==1)
         {

            local_main_window->init_element_energy_spin[j]->setVisible(true);
            local_main_window->init_element_yield_spin[j]->setVisible(true);
            local_main_window->element_yield_spin[j]->setVisible(true);
            local_main_window->efficiency_spin[j]->setVisible(true);
            j++;
         }
     }
    for(unsigned int i=j;i<5;i++)
    {
        local_main_window->fit1_label[i]->setText(" ");
        local_main_window->init_element_energy_spin[i]->setVisible(false);
        local_main_window->init_element_energy_spin[i]->setValue(0);
        local_main_window->init_element_yield_spin[i]->setVisible(false);
        local_main_window->init_element_yield_spin[i]->setValue(0);
        local_main_window->element_yield_spin[i]->setVisible(false);
        local_main_window->element_yield_spin[i]->setValue(0);
        local_main_window->efficiency_spin[i]->setVisible(false);
        local_main_window->efficiency_spin[i]->setValue(0);

    }

    this->close();
}
//////////////////////////////////////////////////////////////////
void TargetWindow::closeEvent(QCloseEvent *event)
{
//    changeEvent(event);
    event->accept();
 emit sendTarget(Target);
}
/*void TargetWindow::changeEvent(QEvent *e)
{

    QWidget::changeEvent(e);

    if (e->type() == QEvent:: ActivationChange && TargetWindow::isActiveWindow() == false )
    {
        Target.clear();

        for(unsigned int i=0;i<(unsigned int)no_elements_spin->value();i++)
        {

            if(link_perc_spin[i]->value() != 0 )
            {
                linked_elem.push_back(link_combo[i]->currentIndex());
                linked_ratio.push_back(link_perc_spin[i]->value());
            }
            else
            {
                linked_elem.push_back(0);
                linked_ratio.push_back(0);
            }

              if(element_combo[i]->currentIndex() == 0)
              {
                  Target.clear();
                  emit sendTarget(Target);
                  return;
               }
            Target.push_back(target_element(Elements[element_combo[i]->currentIndex()-1],
                             atomic_perc_spin[i]->value(),
                             behav_combo[i]->currentIndex(),linked_elem,linked_ratio));

            linked_elem.clear();
            linked_ratio.clear();

        }
     emit sendTarget(Target);
   }

}

*/
void TargetWindow::createActions()
{
    loadTargetAct = new QAction(tr("&Load"), this);
    loadTargetAct->setShortcut(tr("Ctrl+P"));
    loadTargetAct->setStatusTip(tr("Load a target"));
    connect(loadTargetAct, SIGNAL(triggered()), this, SLOT(load_Target()));

    saveTargetAct = new QAction(tr("&Save"), this);
    saveTargetAct->setShortcuts(QKeySequence::Save);
    saveTargetAct->setStatusTip(tr("Save the target"));
    connect(saveTargetAct, SIGNAL(triggered()), this, SLOT(save_Target()));
}

void TargetWindow::createMenus()
{
    menuBar()->addAction(loadTargetAct);
    menuBar()->addAction(saveTargetAct);
}

//////////////////////////////////////////////////////////////////

    void TargetWindow::save_Target()
    {
        QFile savefile;
        QTextStream out(&savefile);
        QString dummy;

        QString fileName = QFileDialog::getSaveFileName(0,"Save target",".",tr("target file (*.trg)"));

        savefile.setFileName(fileName);
        savefile.open(QFile::Text|QFile::WriteOnly);

        for( unsigned int i=0; i < (unsigned int)no_elements_spin->value() ; i++)
        {
            dummy = QString::number(element_combo[i]->currentIndex()+1) + "," + element_combo[i]->currentText()
                                                                           + "," + QString::number(atomic_perc_spin[i]->value())
                                                                           + "," + QString::number(behav_combo[i]->currentIndex());
            if(link_combo[i]->isVisible() == true)
                dummy += ","+link_combo[i]->currentText()+","+QString::number(link_perc_spin[i]->value());
             out << dummy<< endl;
        }
        savefile.close();
    }


void TargetWindow::load_Target()
{
        QFile openfile;
        QTextStream in(&openfile);
        QStringList list,dummy_list;

        QString fileName = QFileDialog::getOpenFileName(0,"Open Target file",".",tr("target file (*.trg)"));
        if(fileName == NULL ) return;
        openfile.setFileName(fileName);
        openfile.open(QFile::Text|QFile::ReadOnly);
        add_fract = 0;
        int no=0;
        Target.clear();
        while(!in.atEnd())
        {
          QString dummy = in.readLine();
          list = dummy.split(QRegExp(","));
          element_combo[no]->setCurrentIndex(list[0].toInt()-1);
          atomic_perc_spin[no]->setValue(list[2].toDouble());
          behav_combo[no]->setCurrentIndex(list[3].toInt());
          element_combo[no]->setHidden(false);
          atomic_perc_spin[no]->setHidden(false);
          behav_combo[no]->setHidden(false);
          if(list.size() > 4)
          {
              dummy_list.append(list[4]);
              link_perc_spin[no]->setValue(list[5].toDouble());
              link_combo[no]->setHidden(false);
              link_perc_spin[no]->setHidden(false);
          }

          no++;

          list.clear();
        }
        no_elements_spin->setValue(no);
        no = 0;
        for(unsigned int i=0; i< (unsigned int)no_elements_spin->value();i++)
            if(link_perc_spin[i]->isVisible()==true)
            {
                link_combo[i]->setCurrentIndex(link_combo[i]->findText(dummy_list[no]));
                no++;
            }
}
void TargetWindow::error_code(int code)
{
    QMessageBox msgBox;
    msgBox.setWindowTitle("Error");
    msgBox.setIcon(QMessageBox::Critical);

    switch (code) {
    case 1:
        msgBox.setText("Empty element in Target");
        break;
    case 2:
        msgBox.setText("Atomic percentage should equal 1");
        break;
    case 3:
        msgBox.setText("Please select an element to remove");
        break;
    case 4:
        msgBox.setText("Target should at least contain two elements");
        break;
    case 5:
        msgBox.setText("Target should contain at least one free and one fit element");
        break;
    case 6:
    //    msgBox.setText("No Available Data for " + QString(name.c_str()) +"\n" +
    //                            "Please change the fit behavior");
        break;
    case 7:
        msgBox.setText("You have selected fewer cross section data \n  than fit elements");
        break;
    case 8:
  //      msgBox.setText("Initial yield of " + QString(name.c_str()) +"\n" +
  //                              "greater than measured yield");
        break;
    case 9:
  //      msgBox.setText("Bombarding energy outside r33 range (" + QString(name.c_str()) +")");
        break;
    case 10:
   //     msgBox.setText("Cutoff energy outside r33 range (" + QString(name.c_str()) + ")");
        break;
    case 11:
   //     msgBox.setText("Bombarding energy less than Cutoff energy (" + QString(name.c_str()) + ")");
        break;
    case 12:
    //    msgBox.setText("Please enter efficiency (" + QString(name.c_str()) + ")");
        break;
    case 13:
   //     msgBox.setText("Charge value not valid");
        break;
    case 14:
   //     msgBox.setText("Negative concentration in the solution (" + QString(name.c_str()) + ")");
        break;
    case 15:
   //     msgBox.setText("The r33 file doesnot contain cross sections");
        break;
    default:
        break;
    }
    msgBox.exec();


}
void TargetWindow::fill_link_combo()
{
QString tmp;
    for(unsigned int i=0;i<(unsigned int)no_elements_spin->value();i++)
        if(link_perc_spin[i]->isVisible()==true)
        {
            tmp = link_combo[i]->currentText();
            link_combo[i]->clear();
            for(unsigned int j=0;j<(unsigned int)no_elements_spin->value();j++)
                if(behav_combo[j]->currentIndex()==0 && element_combo[j]->currentIndex()!=0)
                    link_combo[i]->addItem(element_combo[j]->currentText());
            link_combo[i]->setCurrentIndex(link_combo[i]->findText(tmp));

         }
}
